> For the complete documentation index, see [llms.txt](https://docs.essencefinance.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.essencefinance.io/development/smart-contracts/refs/icoreref.md).

# ICoreRef

## Functions

### setContractAdminRole

```solidity
function setContractAdminRole(
    bytes32 newContractAdminRole
) external
```

#### Parameters

| Name                   | Type    | Description |
| ---------------------- | ------- | ----------- |
| `newContractAdminRole` | bytes32 |             |

### pause

```solidity
function pause() external
```

### unpause

```solidity
function unpause() external
```

### core

```solidity
function core() external returns (contract ICore)
```

### chi

```solidity
function chi() external returns (contract IChi)
```

### zen

```solidity
function zen() external returns (contract IERC20)
```

### chiBalance

```solidity
function chiBalance() external returns (uint256)
```

### zenBalance

```solidity
function zenBalance() external returns (uint256)
```

### CONTRACT\_ADMIN\_ROLE

```solidity
function CONTRACT_ADMIN_ROLE() external returns (bytes32)
```

### isContractAdmin

```solidity
function isContractAdmin(
    address admin
) external returns (bool)
```

#### Parameters

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| `admin` | address |             |

## Events

### CoreUpdate

```solidity
event CoreUpdate(
    address oldCore,
    address newCore
)
```

#### Parameters

| Name                        | Type    | Description |
| --------------------------- | ------- | ----------- |
| `oldCore`                   | address |             |
| `newCore`                   | address |             |
| ### ContractAdminRoleUpdate |         |             |

```solidity
event ContractAdminRoleUpdate(
    bytes32 oldContractAdminRole,
    bytes32 newContractAdminRole
)
```

#### Parameters

| Name                   | Type    | Description |
| ---------------------- | ------- | ----------- |
| `oldContractAdminRole` | bytes32 |             |
| `newContractAdminRole` | bytes32 |             |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.essencefinance.io/development/smart-contracts/refs/icoreref.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
